<template>
  <!--A question object has its own checkbox and a cropped text to show in the QuestionList.
            The v-checkbox waits for an event to call 'updateExport'.-->
  <v-row align="center" class="my-xs-1 mx-sm-3 my-sm-2">
    <v-list-item-content class="ml-2" >
      <v-list-item-title>{{ questionTextCropped }}</v-list-item-title>
    </v-list-item-content>
    <v-list-item-action class="mr-2">
      <v-checkbox v-model="checkbox"></v-checkbox>
    </v-list-item-action>
  </v-row>
</template>

<script>
//An Object from type Question is here required to pass through the code.
export default {
  name: "Question",
  props: {
    question: {
      type: Object,
      required: true
    }
  },
  methods: {
    //updateExport waits to get called from the 'updateCheckbox' method to add or delelte the question object from
    //$store.state.selectedQuestions.
    updateExport: function() {
      if (this.checkbox) {
        this.$store.dispatch("addNewQuestionObject", this.question);
      } else {
        this.$store.dispatch("deleteQuestionObject", this.question);
      }
    },
    //the method waits for an event from the checkbox to call 'updateExport' and updates the checkbox.
    updateCheckbox: function(value) {
      this.$store.dispatch('setCheckboxValueByIndex', {index: parseInt(this.question.number)-1, value: value});
      this.updateExport();
    }
  },
  computed: {
    //questionTextCropped is a function that recudes the length of a question if its too long.
    questionTextCropped: function() {
      let questionTextCropped;
      let maxChars;
      if (this.$vuetify.breakpoint.mdAndDown) {
        maxChars = this.$vuetify.breakpoint.width / 9;
      } else {
        maxChars = this.$vuetify.breakpoint.width / 17;
      }
      if (this.question.text.length > maxChars) {
        questionTextCropped = this.question.text.substring(0, maxChars - 3);
        questionTextCropped += "...";
      } else {
        questionTextCropped = this.question.text;
      }
      return questionTextCropped;
    },
    checkbox: {
      get: function() {
        console.log(parseInt(this.question.number)-1);
        return this.$store.getters.getCheckboxValueByIndex(parseInt(this.question.number)-1);
      },
      set: function(newValue) {
        this.updateCheckbox(newValue);
      }
    }
  }
};
</script>

<style scoped>
.v-label {
  display: none;
}
</style>
